Program SFontGet; { Save current font-data as an SFont-file }
Uses Utils,ASMUtils,STMR_LOW,STMR_MID,STMR_FON;

VAR
 Font              :TSTMRfont;
 XX,YY             :Byte;
 Ch                :Char;
 Done              :Boolean;

 INP               :TInputRec;

 A,B,
 HiMark,LoMark     :Byte;

 INIfile           :String;
 DFilename         :PathStr;
 DAuthor,DDesc     :String[42];


 FCharSet          :Array[1..9] of Array[1..2] of Byte;

label
 ExitNow;

{Procedure Font_LoadBin(const Filename: PathStr;var font: TSTMRfont);
var
 F              :File;
 Dummy          :Word;
begin
 Assign(F,Filename);
 Reset(F,1);
 GetMem(font.data,FileSize(F));
 BlockRead(F,font.data^,FileSize(F),Dummy);
 Close(F);
 font.BPC:=16;
 font.CHARS:=256;
 font.FIRSTCHAR:=0;
end;}

Procedure ReadINIFile;
var
 S              :String;
 T              :Text;
 Loop           :Byte;
 C              :Byte;
begin
 Assign(T,INIFile);
 Reset(T);

 S:='';
 GetINI2(T,'[SFONTGET]','Default.Filename',S);
 if S>'' then DFilename:=S;

 S:='';
 GetINI2(T,'[SFONTGET]','Default.Description',S);
 if S>'' then DDesc:=S;

 S:='';
 GetINI2(T,'[SFONTGET]','Default.Author',S);
 if S>'' then DAuthor:=S;

 for loop:=1 to 9 do
  begin
   S:='';
   GetINI2(T,'[SFONTGET]','CharSet.'+St(Loop),S);
   A:=Va(INIGetCommaPart(S,1));
   B:=Va(INIGetCommaPart(S,2));
   if A>B then begin
    C:=A;
    A:=B;
    B:=C;
   end;
   if A<>B then begin
    FCharSet[loop,1]:=B;
    FCharSet[loop,2]:=A;
   end;
  end;
 Close(T);
end;


Procedure UpdateTable;
var
 X,Y,A,C       :Byte;
begin
 a:=0;
 for Y:=1 to 8 do
  for X:=1 to 32 do
   begin
    if (A>=LoMark) AND (A<=HiMark) then C:=$0F+128 else C:=$07+128;
    WriteXYC((XX-33)+(X*2)-1,YY+Y,C,Chr(a));
    Inc(a);
   end;
 WriteXY(XX-3,YY+12,Char(LoMark));
 WriteXY(XX+2,YY+12,Char(HiMark));

end;

BEGIN
 SetBlink(FALSE);
 HideCursor;

 YY:=(SH div 2) div 4;
 XX:=(SW div 2);

 FCharSet[1,2]:=0;
 FCharSet[1,1]:=255;
 DFilename:='';
 DAuthor:='n/a';
 DDesc:='"<fontname>" [keyword]';

 INIFile:=ParamStr(1);
 if NOT Exist(INIFile) then INIFile:=ProgramPath(ParamStr(0))+'SFONT.INI';
 if Exist(INIFile) then ReadINIFile;

 WindowBox(XX-35,YY-1,70,20,143,128,143,SinFrame,False);
 CentreC(' SaruFONT Fetch (C)1997 Saruman / DFR Research & Engineering ',YY-1,112);

 CentreC('Use the arrow keys '#17#24#25#16' to choose characters, then press ENTER.',YY+10,138);

 LoMark:=FCharSet[1,2];
 HiMark:=FCharSet[1,1];

 CentreCode('~[~''~ ~''..''~ ~''~]',YY+12);
 UpdateTable;

 Done:=False;
 REPEAT
  Ch:=ReadKey;
  if Ch=#0 then begin
   Ch:=ReadKey;
   a:=LoMark;
   b:=HiMark;
   if Ch=LeftKey then if LoMark>0 then Dec(LoMark);
   if Ch=RightKey then if LoMark<HiMark then Inc(LoMark);
   if Ch=UpKey then if HiMark<255 then Inc(HiMark);
   if Ch=DownKey then if HiMark>LoMark then Dec(HiMark);
  end;
  if Ch=ENTER then Done:=True;
  if Ch=ESC then goto ExitNow;
  if Ch in ['1'..'9'] then
   begin
    if FCharSet[Ord(Ch)-48,1]<>FCharSet[Ord(Ch)-48,2] then begin
     HiMark:=FCharSet[Ord(Ch)-48,1];
     LoMark:=FCharSet[Ord(Ch)-48,2];
    end;
   end;
  if (LoMark<>a) or (HiMark<>b) then UpdateTable;
 UNTIL Done;

 With INP do begin
  X:=XX-20;
  Y:=YY+14;
  StartS:=DDesc;
  S:='';
  MaxLen:=SizeOf(font.Description)-1;
  Width:=MaxLen;
  StartPos:=Length(StartS);
  BackChar:='';
  Insert:=True;
  Arrows:=False;
  AcceptSet  :=[#32..#254];
  NormExitSet:=[#27,#13];
  ExtExitSet :=[#72,#80];
 end;

 { Get description }
 WriteXYC(XX-33,INP.Y,$8A,'Description:');
 TInput(INP);
 if (Hi(INP.Status)=27) then goto ExitNow;
 Font.Description:=INP.S;

 { Get author }
 Inc(INP.Y);
 INP.MaxLen:=SizeOf(font.Author)-1;
 INP.Width:=INP.MaxLen;
 INP.StartS:=DAuthor;
 INP.StartPos:=Length(INP.StartS);
 Dec(INP.X,5);
 WriteXYC(XX-33,INP.Y,$8A,'Author:');
 TInput(INP);
 if (Hi(INP.Status)=27) then goto ExitNow;
 Font.Author:=INP.S;

 { Get filename }
 Inc(INP.Y);
 INP.MaxLen:=127;
 INP.Width:=30;
 INP.StartS:=DFilename;
 INP.StartPos:=Length(INP.StartS);
 Inc(INP.X,2);
 WriteXYC(XX-33,INP.Y,$8A,'Filename:');
 TInput(INP);
 if (Hi(INP.Status)=27) then goto ExitNow;

 HideCursor;

 if (Hi(INP.Status)=13) AND (INP.S>'') AND (INP.S[Length(INP.S)]<>'\') then
 begin
  Font.Version:=1;
  Font.BPC:=Font_GetCurrentBPC;
  Font.FIRSTCHAR:=LoMark;
  Font.CHARS:=(HiMark-LoMark)+1;
  GetMem(Font.data,Font.BPC*Font.CHARS);
  Font_Fetch(Font);
  Font_Save(INP.S,Font);
  WindowBox2(XX-20,YY+6,39,5,$78,$7F,$71,SinFrame,0,$4E,' Information ',True);
  Centre('SFont File Written, '+St(
    (Font.BPC*Font.CHARS)+
    SizeOf(TSTMRFont)-4+
    SizeOf(TSTMRFont_ID))+' bytes.',YY+8);
 end else begin
exitnow:
  WindowBox2(XX-20,YY+6,39,5,$78,$7F,$71,SinFrame,0,$4E,' Information ',True);
  Centre('Aborted.',YY+8);
 end;
  Delay(1200);

 ClrScr;
 GotoXY(0,0);
 SetBlink(TRUE);
 NormalCursor;

END.
