Unit STMR_MID; { Sarumans Text Mode Routines (Mid-level) }
{
  STMR_MID v0.0.1 - (C)1996,97 Eddy L O Jansson / DFR Research & Engineering

  Various "mid-level" routines to manipulate textmodes. Supports extended
  (SVGA) textmodes (132*43, 132*25, etc).

    ** This isn't a finished library, I'm still building on this. **

 Shortcommings:

  No Monochrome support.

 Copyright:

  This is FREEWARE. Use it, modify it, spread it. If you want you can send
  me a 'thank you' e-mail, or maybe a free copy of whatever you've made.

  E-mail: eddy@saru.ct.se     FidoNET: 2:206/233     KlopperNET: 204:16/100
}
INTERFACE
Uses STMR_LOW,STMR_STR,STMR_FON,ASMUtils;

type
 FrameType        = String[6];
 CharSet          = Set of Char;

 PByteParam       = Procedure(const B: Byte);

 Static_VidInfoRec = Record
  Sup_VidModes1       :Byte;
  Sup_VidModes2       :Byte;
  Sup_VidModes3       :Byte;
  RESERVED            :LongInt;
  Sup_Scanlines       :Byte;
  MaxTextCharSets     :Byte;
  TextDefsInCharRAM   :Byte;
  Capabilities1       :Byte;
  Capabilities2       :Byte;
  RESERVED2           :Word;
  SaveAreaCapabil     :Byte;
  RESERVED3           :Byte;
 end;

 Dynamic_VidInfoRec = Record
  StaticTable           :Pointer;
  VideoMode             :Byte;
  Columns               :Word;
  VideoBufSize          :Word;
  VideoBufStart         :Word;
  CursorPosTable        :Array[1..8] of Word; {col,row}
  CursorEndLine         :Byte;
  CursorStartLine       :Byte;
  ActiveVideoPage       :Byte;
  CRTC_addr_port        :Word;
  CRTC_3x8_reg          :Byte;
  CRTC_3x9_reg          :Byte;
  Disp_Char_Rows        :Byte;
  Char_Matrix_Height    :Word; { in points }
  ActiveDisplayCode     :Byte;
  InActiveDisplayCode   :Byte;
  DisplayedColors       :Word; { mono = 0 }
  Supported_VidPages    :Byte;
  ScanLines             :Byte; { 0=200, 1=350, 2=400, 3=480 }
  TextCharTable1        :Byte;
  TextCharTable2        :Byte;
  StateInfo1            :Byte;
  RESERVED              :Array[1..3] of Byte;
  VideoRAM              :Byte; { 0=64K, 1=128K, 2=192K, 3=256K }
  SaveAreaStatus        :Byte;
  RESERVED2             :LongInt;
 end;

 TInputRec = Record { 267 bytes. Increase string length as needed. }
  X,Y         :Byte;         { Position of input }
  S           :String[255];   { Outstring (result) }
  StartS      :String[255];   { Default string }
  Width       :Byte;         { Width of edit-window }
  MaxLen      :Byte;         { Maximum string-length allowed to be input }
  StartPos    :Byte;         { Where to start edit. -1 = end of string }
  BackChar    :Char;         { Background character. #176 is nice. }
  Arrows,                    { Use 'direction' arrows? }
  Insert      :Boolean;      { Insert or Overwrite? }
  AcceptSet   :Set of Char;  { Standard keys accepted as input }
  NormExitSet :Set of Char;  { Standard keys to exit in }
  ExtExitSet  :Set of Char;  { Extended keys to exit on }
  Status      :Word;         { Returns the key used to terminat the routine }
                           { If extended key then status = $00xx else $xx00 }
 end;

const
 NilFrame: FrameType='      ';      { frame 0 }
 SinFrame: FrameType='ĳڿ';      { frame 1 }
 DouFrame: FrameType='ͺɻȼ';      { frame 2 }
 SveFrame: FrameType='ĺַӽ';      { frame 3 }
 ShoFrame: FrameType='ͳոԾ';      { frame 4 }

 {$I C:\UTILS\BP\INCLUDE\KEYCONST }

{-[ Function Interface ]----------------------------------------------------}

Procedure ScreenStore(var Screen: Pointer);
{
 Description: Store the contents of the visible page (0).

 See also: #ScreenRestore#
}

Procedure ScreenRestore(const Screen: Pointer);
{
 Description: Retrieve the contents of a previously stored text page.

 See also: #ScreenStore#
}

Procedure WindowBox(const x,y,w,h,HiAttr,LoAttr,BackAttr: Byte;
                    const Frame: FrameType;const Shadow: Boolean);
{
  Written: 96-xx-xx, Eddy L O Jansson (2:206/233)

  Description: Draw a rectangular window on the current page. The
  *Attr parameters define the attribute for the left-upper frame,
  right-lower frame and the background respectively. #FrameType#
  is a 6 byte string of the form 'ĳڿ', used to draw the frame.
  Shadow is a boolean, specifying wheter or not a shadow is wanted
  under the window.

  Example: WindowBox(0,0,SW,SH,$7F,$78,$7F,SinFrame,False);

  Known bugs: The window/shadow will wrap if written past #SH#/#SW#.

  See also: #WindowBox2# #GrayMessageBox# #AttentionWindow#
}
Procedure WindowBox2(const X,Y,W,H,HiAttr,LoAttr,BackAttr: Byte;const Frame: FrameType;
                     const HeadOfs,HeadAttr: Byte;const Header: String;const Shadow: Boolean);
{
 Written: 96-xx-xx, Eddy L O Jansson (2:206/233)

 Description: As #WindowBox# but with a twist, the header.

 Example:

 WindowBox2(0,0,SW,SH-1,$7F,$78,$7F,SinFrame,1,$1B,' WindowBox2() ',False);

 See also: #WindowBox# #GrayMessageBox# #AttentionWindow#
}
Procedure GrayMessageBox(const S: String;const Y: Byte);

Procedure AttentionWindow(const X,Y,W,H,ATTR,BACK: Byte);

Function Input(X,Y: Byte;StartStr: String;BackG: Char;MaxLen,StartPos:
               Integer;AcceptSet: CharSet;Ins: Boolean;var InputStatus: Byte): String;

{ ** Rewrite to work with different widths!
Procedure NCButton(const nr: byte;const s: string);
Procedure NCBottomLine(const s1,s2,s3,s4,s5,s6,s7,s8,s9,s10: string);
}
Function ChooseAttr(const X,Y,DefaultAttr: Byte;var ATTR: Byte;
                    UpdateProc: PByteParam): Boolean;
{
  Written: 96-12-15, Eddy L O Jansson (2:206/233)

  Description: Small function to easily choose an attribute. A perfect
  tool for your toolbox and easily adapted to fit into your programs.
}

Function LightBar(const X,Y,W,H,StartPos,BackAttr,BarAttr: Byte): Byte;
{
  Written: 96-12-15, Eddy L O Jansson (2:206/233)

  Description: Pretty mush self-explainatory. Try it out.

  Example: p:=LightBar(25,5,12,10,$78,$1E);
}

Procedure Get_DynamicVidInfo(var TVidInfo);
{
  Written: 97-01-19, Eddy L O Jansson (2:206/233)

  Description: Fill in/update a 'DynamicVideoInfo' record.

  See also #Dynamic_VidInfoRec# #Static_VidInfoRec#

 Example:

 Program Test_Get_DynamicVidInfo;
 VAR
  V             :Dynamic_VidInfoRec;
  S             :^Static_VidInfoRec;

 BEGIN
  Get_DynamicVidInfo(V);
  New(S);
  S:=V.StaticTable;
  WriteLn('Video Buffer Size: ',V.VideoBufSize);
  WriteLn('Supported Scanlines: ',S^.Sup_Scanlines);
 END.
}

Procedure TInput(var TI: TInputRec);

Procedure StatusBar(X,Y,W: Byte;MaxValue,CurrValue: LongInt);

Function InputSBox(const XX,YY,MaxL: Byte;Title: String): String;

Procedure ProgressBar(const X,Y,W,Percentage: Byte);
{
 Written: 97-07-12, Eddy L O Jansson (2:206/233)

 Description:

 text-mode progress bar. Supply the X,Y,Width and %full.

 See also: #ProgressBarSmooth#
}

Procedure ProgressBarSmooth(const X,Y,W,Percentage: Byte);
{
 Written: 97-07-12, Eddy L O Jansson (2:206/233)

 Description:

 A 'smooth' text-mode progress bar. Supply the X,Y position, Width
 and the 'current state', in percent.

 This procedure will redefine ASCII 1 to create a smooth progression. A
 simpler version which lacks this feature is available as #ProgressBar#.

 See also: #ProgressBar#
}

{-[ Implementation / Code ]-------------------------------------------------}

IMPLEMENTATION

Procedure ScreenStore(var Screen: Pointer);
begin
 GetMem(Screen,PageSize);
 Move32(Mem[$B800:0000],Screen^,PageSize);
end;

Procedure ScreenRestore(const Screen: Pointer);
begin
 Move32(Screen^,Mem[$B800:0000],PageSize);
 FreeMem(Screen,PageSize);
end;

Procedure WindowBox(const x,y,w,h,HiAttr,LoAttr,BackAttr: Byte;
                    const Frame: FrameType;const Shadow: Boolean);
begin
 BoxCharAttr(x,y,w,h,Word(BackAttr SHL 8)+32);
 DrawVCharAttr(x+w-1,y+1,h-2,Word(LoAttr SHL 8)+Ord(Frame[2]));
 DrawVCharAttr(x,y+1,h-2,Word(HiAttr SHL 8)+Ord(Frame[2]));
 DrawHCharAttr(x+1,y,w-2,Word(HiAttr SHL 8)+Ord(Frame[1]));
 DrawHCharAttr(x+1,y+h-1,w-2,Word(LoAttr SHL 8)+Ord(Frame[1]));
 SetCharAttrXY(x,y,Word(HiAttr SHL 8)+Ord(Frame[3]));
 SetCharAttrXY(x,y+h-1,Word(HiAttr SHL 8)+Ord(Frame[5]));
 SetCharAttrXY(x+w-1,y,Word(LoAttr SHL 8)+Ord(Frame[4]));
 SetCharAttrXY(x+w-1,y+h-1,Word(LoAttr SHL 8)+Ord(Frame[6]));
 if Shadow then
 begin
  DrawVAttr(x+w,y+1,h,8);
  DrawHAttr(x+1,y+h,w,8);
 end;
end;

Procedure WindowBox2(const X,Y,W,H,HiAttr,LoAttr,BackAttr: Byte;const Frame: FrameType;
                     const HeadOfs,HeadAttr: Byte;const Header: String;const Shadow: Boolean);
begin
 WindowBox(X,Y,W,H,HiAttr,LoAttr,BackAttr,Frame,Shadow);
 WriteXYC(X+1+HeadOfs,Y,LoAttr,'=[');
 WriteXYC(X+4+HeadOfs,Y,HeadAttr,Header);
 WriteXYC(X+4+HeadOfs+Length(Header),Y,LoAttr,']=');
end;

Procedure GrayMessageBox(const S: String;const Y: Byte);
var
 X              :Byte;
begin
 X:=(SW div 2)-(Length(S) div 2)-1;
 if Length(S) MOD 2=1 then Dec(X);
 WindowBox(X,Y-1,Length(S)+2,3,127,120,126,SinFrame,True);
 Centre(S,Y);
end;

Procedure AttentionWindow(const X,Y,W,H,ATTR,BACK: Byte);
var
 XX,YY          :Byte;
begin
 for YY:=Y to Y+H-1 do
  begin
   DrawHCharAttr(X,YY,W,Word(ATTR SHL 8)+32);
   SetAttrXY(X+W,YY,BACK);
   if YY-Y=0 then SetCharXY(X+W,YY,220) else SetCharXY(X+W,YY,219);
  end;
  DrawHCharAttr(X+1,YY+1,W,Word(BACK SHL 8)+Ord(''));
end;

Function Input(X,Y: Byte;StartStr: String;BackG: Char;MaxLen,StartPos:
               Integer;AcceptSet: CharSet;Ins: Boolean;var InputStatus: Byte): String;
{Version 1.5}
Var
P:      Byte;
Exit:   Boolean;
ch:     Char;
ext:    Char;
s:      String;
t:      String[1];

Function ReadKey: Char; inline($B4/$08/$CD/$21);

begin
Exit:=False;                                      { Don't quit on me yet! }
if BackG='' then BackG:=' ';
if Length(StartStr)>MaxLen then Left(StartStr,MaxLen);
if StartPos>Length(StartStr) then StartPos:=Length(StartStr);
if StartPos=-1 then StartPos:=Length(StartStr);
If StartPos>=MaxLen then StartPos:=MaxLen-1;

s:=StartStr;                                { Put StartStr into Edit Buffer }
WriteXY(X,Y,RepeatChar(BackG,MaxLen));

if StartStr<>'' then WriteXY(X,Y,StartStr);

p:=StartPos;
GotoXY(X+StartPos,Y);

repeat
 if Ins then NormalCursor else BlockCursor;
 ext:=#0;
 ch:=ReadKey;
 if ch=#0 then ext:=ReadKey;
 if ch=#27 then begin
                 InputStatus:=27;
                 Exit:=True;
                end;
{   (ch<#255) and (ch>#31) }
if ch in AcceptSet then
  begin   { Welcome to the jungle...}
   t:=ch;
    if (p=length(s)) and (Length(s)<MaxLen) then
     begin
      s:=s+t;
      WriteXY(X+P,Y,T);
      Inc(p);
     end else
      if length(s)<MaxLen then
       begin
        if Ins then Insert(T,S,P+1) else s[p+1]:=Ch;
        WriteXY(X+P,Y,Copy(S,P+1,Length(S)));
        Inc(p);
       end else if (Length(s)=MaxLen) and (not Ins) then
         begin
          s[p+1]:=ch;
          WriteXY(X+P,Y,T);
          Inc(p);
         end;
      ch:=#0;
      if p>MaxLen-1 then p:=MaxLen-1;
      GotoXY(X+P,Y);
     end else
begin
 case ch of { CTRL-Y }
  #25:   begin
          WriteXY(X,Y,RepeatChar(BackG,Length(S)));
          P:=0;
          S:='';
          GotoXY(X,Y);
         end;
 {Backspace}
 #8: If (P>0) then
  begin
   if (p+1=MaxLen) and (p<length(s)) then Ext:=#83 else
    begin
     Delete(S,P,1);
     Dec(P);
     GotoXY(X+P,Y);
     WriteXY(X+P,Y,Copy(S,P+1,Length(s))+BackG)
    end;
  end;

  #9: begin { Exit on TAB }
       InputStatus:=9;
       Exit:=True;
      end;

 #13: begin
       InputStatus:=13;
       Exit:=True;
      end;
 end; { Case CH of }

 case ext of
 #75: if P>0 then begin
 {Left Arrow}      Dec(P);
                   GotoXY(X+P,Y);
                  end;

 #77: if (P<Length(s)) and (P+1<MaxLen) then begin
 {Right Arrow}             Inc(P);
                           GotoXY(X+P,Y);
                          end;

 #82: Ins:=Not(Ins); {Insert}
 {Delete}
 #83: If P<Length(s) then begin
                           Delete(S,P+1,1);
                           WriteXY(X+P,Y,Copy(S,P+1,Length(s))+BackG);
                          end;

 #71: begin
       p:=0;
       GotoXY(X+P,Y);
      end;

 #79: begin
       p:=Length(s);
       if p>=MaxLen then P:=MaxLen-1;
       GotoXY(X+P,Y);
      end;

 #72,#73,#80,#81,#59..#68:
  begin
   InputStatus:=Ord(Ext);
   Exit:=True;
  end;

 end; {Case of EXT }
end; { if not normal char }

until Exit;
Input:=S;
end;

Procedure NCButton(const nr: byte;const s: string);
{ calculate width of one button. = SW div buttons-(buttons*2)
  pos = button*width_of_button+(button*2)
}
var
 loop:   byte;

begin
 SetAttrXY((nr-1)*8,SH-1,7);
 SetAttrXY((nr-1)*8+1,SH-1,7);
if nr<10 then begin
 SetCharXY((nr-1)*8,SH-1,48+nr);
 for loop:=1 to 6 do SetAttrXY((nr-1)*8+loop,SH-1,48);
 for loop:=1 to length(s) do SetCharXY((nr-1)*8+loop,SH-1,ord(s[loop]));
 end else
     begin
      SetCharXY(73,SH-1,49);
      SetCharXY(74,SH-1,48);
      for loop:=1 to 8 do SetAttrXY(74+loop,SH-1,48);
      for loop:=1 to length(s) do SetCharXY(74+loop,SH-1,ord(s[loop]));
     end;
end;

Procedure NCBottomLine(const s1,s2,s3,s4,s5,s6,s7,s8,s9,s10: string);
begin
 NCButton(1,s1); NCButton(2,s2); NCButton(3,s3); NCButton(4,s4);
 NCButton(5,s5); NCButton(6,s6); NCButton(7,s7); NCButton(8,s8);
 NCButton(9,s9); NCButton(10,s10);
end;

Function ChooseAttr(const X,Y,DefaultAttr: Byte;var ATTR: Byte;UpdateProc: PByteParam): Boolean;
{
 Possible extensions:
  * Pass-thru of characters to external procedure.
}
const
 BackChar :Byte=7;
 MarkChar :Byte=8;

var
 XX,YY,OX,OY    :Byte;
 C              :Byte;
 Ch             :Char;
 OldBack        :Pointer;
 Blink,HiBack   :Boolean;

 Procedure DrawColorTable(const Blink: Boolean);
 var
  XX,YY,C         :Byte;
 begin
  C:=255;
  for YY:=Y+1 to Y+8 do
   for XX:=X+1 to X+16 do
    begin
     Inc(C);
     SetCharAttrXY(XX,YY,Word((C+(Byte(Blink) SHL 7)) SHL 8)+BackChar);
    end;
 end;

begin
 GetMem(OldBack,(16+2)*(8+2)+4);
 TextBoxGet(X,Y,16+2,8+2,OldBack);
 WindowBox(X,Y,16+2,8+2,12,4,0,SinFrame,False); { No shadows }
 C:=DefaultAttr;
 { Check/Fixup if default-attr is blinking }
 if C>127 then
  begin
   Dec(C,127);
   Blink:=True;
  end else Blink:=False;
 DrawColorTable(Blink);
 { Convert 1D Attribute into 2D Screen-coords }
 XX:=(C mod 16)+1;
 YY:=((C div 16) mod 8)+1;
 { Main loop }
 Repeat
  { Optional; Call external user procedure with attribute as parameter }
  if @UpdateProc<>nil then UpdateProc(C);

  WriteXYC(X+8,Y+9,78,HexB(C));
  SetCharXY(X+XX,Y+YY,MarkChar);
  Ch:=ReadKey;
  OX:=XX; OY:=YY;
  { Read cursor keys }
  if Ch=#0 then begin
   Ch:=ReadKey;
   if (Ch=LeftKey) and (XX>1) then Dec(XX);
   if (Ch=RightKey) and (XX<16) then Inc(XX);
   if (Ch=UpKey) and (YY>1) then Dec(YY);
   if (Ch=DownKey) and (YY<8) then Inc(YY);
  end else begin
   { Toggle High-intensity background colors On/Off }
   if (Ch='H') or (Ch='h') then
    begin
     HiBack:=NOT HiBack;
     SetBlink(HiBack);
    end;
   { Toggle Blink On/Off }
   if (Ch='B') or (Ch='b') then
    begin
     Blink:=NOT Blink;
     DrawColorTable(Blink);
    end;
   end;
  { If choose new attribute then ... }
  if (OX<>XX) or (OY<>YY) then SetCharXY(X+OX,Y+OY,BackChar);
  { Calculate 1D Attribute from 2D coordinates }
  C:=(XX+((YY-1)*16)-1)+(Byte(Blink) SHL 7);
 Until (Ch=ESC) or (Ch=ENTER); { Main loop }
 TextBoxPut(X,Y,OldBack);
 FreeMem(OldBack,(16+2)*(8+2)+4);
 if Ch=ENTER then
  begin
   Attr:=C;
   ChooseAttr:=True;
  end else ChooseAttr:=False;
end;

Function LightBar(const X,Y,W,H,StartPos,BackAttr,BarAttr: Byte): Byte;
var
 Ch             :Char;
 Done           :Boolean;
 OldPos,Pos     :Byte;
begin
 Done:=False;
 Pos:=StartPos;
 While NOT Done do
  begin
   DrawHAttr(X,Y+Pos-1,W,BarAttr);
   Ch:=ReadKey;
   if Ch=#0 then
    begin
     Ch:=ReadKey;
     OldPos:=Pos;
     if (Ch=DownKey) and (Pos<H) then Inc(Pos);
     if (Ch=UpKey) and (Pos>1) then Dec(Pos);
     if (Ch=Home) then Pos:=1;
     if (Ch=EndKey) then Pos:=H;
     if OldPos<>Pos then DrawHAttr(X,Y+OldPos-1,W,BackAttr);
    end else begin
     If (Ch=ENTER) or (Ch=ESC) then Done:=True;
    end;
  end;
 if Ch=ENTER then LightBar:=Pos else LightBar:=0;
end;

Procedure Get_DynamicVidInfo(var TVidInfo); Assembler;
asm
 mov ah,$1B
 xor bx,bx
 mov dx,seg TVidInfo
 mov es,dx
 mov dx,offset TVidInfo
 mov di,dx
 int $10
end;

Procedure StatusBar(X,Y,W: Byte;MaxValue,CurrValue: LongInt);
var
 WW             :Byte;
begin
 WW:=Trunc((CurrValue/MaxValue*100)/(100/W));
 if WW<1 then WW:=1;
 if WW>W then WW:=W;
 DrawHChar(X,Y,WW,219);
end;

Procedure TInput(var TI: TInputRec);
{ This is the /static/ version. Consider a 'UpdateIfKeypressed' version }
var
 Done           :Boolean; { Exit routine if TRUE }
 P              :Byte;    { Pointer into the string }
 LP             :Byte;    { Pointer into pos of string in leftmost pos of window }
 Ch,ChE         :Char;
 VP             :Integer; { Cursorpos in window (0 to TI.Width-1 }
 S,SS           :String;  { local temp-variables }

Procedure UpdateWindow;
begin
 Copy_P(S,LP,TI.Width,SS);
 PadRight_P(SS,Ti.Width,Ord(TI.BackChar));
 WriteXY(TI.X,TI.Y,SS);
 if TI.Arrows then begin
  if LP>1 then WriteXY(TI.X-1,TI.Y,#17) else WriteXY(TI.X-1,TI.Y,#32);
  if Length(S)>=LP+TI.Width then WriteXY(TI.X+TI.Width,TI.Y,#16) else WriteXY(TI.X+TI.Width,TI.Y,#32);
 end;
 GotoXY(TI.X+VP,TI.Y);
end;

Procedure MoveCursLeft;
begin
 Dec(P); Dec(VP);
 if VP<0 then begin Dec(LP); VP:=0; end;
 UpdateWindow;
end; { LeftKey }

Procedure MoveCursRight;
begin
 if P+1<TI.MaxLen then
  begin
   Inc(P); Inc(VP);
   if VP>TI.Width-1 then begin Inc(LP); VP:=TI.Width-1; end;
  end;
 UpdateWindow;
end; { RightKey }

Procedure doExtendedKey;
begin
 ChE:=ReadKey; { Read Extended Key }

 if NOT (ChE in TI.ExtExitSet) then begin

 { Leftkey }
 if (ChE=#75) AND (P>0) then MoveCursLeft;
 { Rightkey }
 if (ChE=#77) AND (P<Length(S)) then MoveCursRight;
 { Insert/Overwrite }
 if (ChE=#82) then
  begin
   TI.Insert:=NOT TI.Insert;
   if TI.Insert then NormalCursor else BlockCursor;
  end;
 { Home }
 if (ChE=#71) then
  begin
   P:=0; VP:=0; LP:=1;
   UpdateWindow;
  end;
 { End }
 if (ChE=#79) then
  begin
   P:=Length(S);
   VP:=MinI(Length(S),TI.Width-1);
   LP:=MaxI(1,P-TI.Width+2);
   UpdateWindow;
  end;
 { Delete }
 if (ChE=#83) then
  begin
   Delete(S,P+1,1);
   UpdateWindow;
  end;
 end else begin Done:=True; TI.Status:=Ord(ChE); end;
end; { doExtendedKey }

Procedure doNormalKey;
begin
 if Length(S)<TI.MaxLen then
 begin
  if TI.Insert then begin
   Insert(Ch,S,P+1);
   MoveCursRight;
  end else begin { if overwrite }
   if P+1>Length(S) then S:=S+Ch else S[P+1]:=Ch;
   MoveCursRight;
  end;
 end; { if not string too long }
end; { doNormalKey }

begin
 { Fix background character }
 if TI.BackChar='' then TI.BackChar:=' ';
 { Don't allow entering of strings longer than supported by the structure }
 if TI.MaxLen>SizeOf(TI.S)-1 then TI.MaxLen:=SizeOf(TI.S)-1;
 { Truncate string if longer than allowed }
 if Length(TI.StartS) > TI.MaxLen then TI.StartS:=Left(TI.StartS,TI.MaxLen);
 { Fix startpos if larger than string }
 if TI.StartPos > Length(TI.StartS) then TI.StartPos:=Length(TI.StartS);
 { Setup local edition of TI.startS }
 S:=TI.StartS;
 { Write the 'entry-form' }
 WriteXY(TI.X,TI.Y,RepeatChar(TI.BackChar,TI.Width));
 { Setup a most important variable, the pointer into the string }
 P:=Ti.StartPos;
 { Setup VP (cursorpos) }
 VP:=MinI(Length(S),TI.Width-1);
 { Setup LP - The start-pos of the string in the window }
 LP:=MaxI(1,P-TI.Width+2); { +2 because we want to start _behind_ the string }
 { Update the entry-window }
 if TI.Insert then NormalCursor else BlockCursor;
 UpdateWindow;
 Done:=False;
 REPEAT
  Ch:=ReadKey;
  if Ch in TI.NormExitSet then
   begin
    Done:=True;
    TI.Status:=Word(Ord(Ch) SHL 8);
   end else begin
    if Ch=#0 then doExtendedKey else
     if Ch in TI.AcceptSet then doNormalKey else
      begin { Very special keys }
       { Backspace }
       if (Ch=#8) and (P>0) then
        begin
         Delete(S,P,1);
         MoveCursLeft;
        end;
       { CTRL+Y }
       if (Ch=#25) then
        begin
         S:=''; VP:=0; P:=0; LP:=1;
         UpdateWindow;
        end;
      end; { .. was special-special key }

   end; { take care of character }
 UNTIL Done;
 TI.S:=S;
end;

Function InputSBox(const XX,YY,MaxL: Byte;Title: String): String;
var
 I          :TInputRec;
 OldScreen  :Pointer;
 Wi         :Byte;
begin
{ ScreenStore(OldScreen);}
 Wi:=MinI(MaxL+4,SW-XX);
 TextBoxGet(XX,YY,Wi+4,5,OldScreen);
 WindowBox2(XX,YY,Wi+4,5,127,112,127,SinFrame,0,62,' '+Title+' ',True);
 With I do begin
  X:=XX+2;
  Y:=YY+2;
  StartS:='';
  S:='';
  Width:=Wi;
  MaxLen:=MinI(SizeOf(S)-1,MaxL);
  StartPos:=Length(StartS);
  BackChar:='';
  Insert:=True;
  Arrows:=True;
  AcceptSet:=[#32..#255];
  NormExitSet:=[#27,#13];
  ExtExitSet:=[#72,#80];
 end;
 SetAttrXY(I.X-1,I.Y,113);
 SetAttrXY(I.X+I.Width,I.Y,113);
 TInput(I);
 HideCursor;
{ ScreenRestore(OldScreen);}
 TextBoxPut(XX,YY,OldScreen);
 InputSBox:=I.S;
end;

Procedure ProgressBar(const X,Y,W,Percentage: Byte);
var
 whole                  :Word;
begin
 if Percentage=0 then Exit;
 if Percentage>99 then begin WriteXY(X,Y,RepeatChar(#219,W)); Exit; end;
 whole:=Trunc(W/(100/Percentage));
 WriteXY(X,Y,RepeatChar(#219,Whole));
end;

Procedure ProgressBarSmooth(const X,Y,W,Percentage: Byte);
const
 PartData :Array[1..7] of Byte=(128,192,224,240,248,252,254);
var
 BPC                    :Byte;
 Backgroundchar         :Byte;
 whole,part             :Word;
 C                      :Pointer; { Holds redefined characted data }
begin
 if Percentage=0 then Exit;
 if Percentage>99 then begin WriteXY(X,Y,RepeatChar(#219,W)); Exit; end;
 whole:=Trunc((W*8)/(100/Percentage));
 part:=whole mod 8;
 whole:=whole div 8;

 { This part will OR the progress-meter with the background character }
 if Part<7 then
 begin
  BPC:=Font_GetCurrentBPC;
  GetMem(C,BPC);
  BackgroundChar:=GetCharXY(X+Whole,Y);
  Font_FetchChar(BackgroundChar,C^);
  asm
   push ds
   lea  si,PartData
   add  si,part
   mov  bl,byte ptr [si]
   lds  si,C
   les  di,C
   @again:
   lodsb          { get original bitmap  }
   or   al,bl     { OR with progress-bitmap }
   stosb          { store the result }
   loop @again
   pop  ds
  end;
  WaitVBL;   { You might want to [re]move this if you are loading massive }
             { amounts of data and are calling this procedure often. }
  Font_Define(1,BPC,C^); { Redefine character #1 }
  FreeMem(C,BPC);
  WriteXY(X,Y,RepeatChar(#219,Whole)+#1);
 end else WriteXY(X,Y,RepeatChar(#219,Whole));
end;

BEGIN
 { Setup/Initialization }
END.
